diff --git a/tests/test_hobo_notify.py b/tests/test_hobo_notify.py
index 79f4462b..724516ed 100644
--- a/tests/test_hobo_notify.py
+++ b/tests/test_hobo_notify.py
@@ -1,14 +1,12 @@
 # -*- coding: utf-8 -*-
-import shutil
-from quixote import cleanup
+import uuid
 
 from wcs.qommon import force_str
 from wcs.qommon.http_request import HTTPRequest
 from wcs.ctl.hobo_notify import CmdHoboNotify
-from wcs.roles import Role
 from wcs.qommon import storage as st
 
-from utilities import create_temporary_pub, clean_temporary_pub
+from utilities import create_temporary_pub
 
 import pytest
 
@@ -27,8 +25,8 @@ def pub(request):
     pub.cfg['sp'] = {'saml2_providerid': 'test'}
     pub.write_cfg()
 
-    Role.wipe()
-    r = Role(name='Service étt civil')
+    pub.role_class.wipe()
+    r = pub.role_class(name='Service étt civil')
     r.slug = 'service-ett-civil'
     r.store()
 
@@ -36,8 +34,6 @@ def pub(request):
 
 
 def test_process_notification_role_wrong_audience(pub):
-    User = pub.user_class
-
     notification = {
         '@type': u'provision',
         'audience': [u'coin'],
@@ -49,7 +45,7 @@ def test_process_notification_role_wrong_audience(pub):
                     'name': u'Service enfance',
                     'slug': u'service-enfance',
                     'description': u'Rôle du service petite enfance',
-                    'uuid': u'12345',
+                    'uuid': str(uuid.uuid4()),
                     'emails': [u'petite-enfance@example.com'],
                     'emails_to_members': False,
                 },
@@ -58,31 +54,31 @@ def test_process_notification_role_wrong_audience(pub):
                     'name': u'Service état civil',
                     'slug': u'service-etat-civil',
                     'description': u'Rôle du service état civil',
-                    'uuid': u'xyz',
+                    'uuid': str(uuid.uuid4()),
                     'emails': [u'etat-civil@example.com'],
                     'emails_to_members': True,
                 },
             ],
         },
     }
-    assert Role.count() == 1
-    assert Role.select()[0].name == 'Service étt civil'
-    assert Role.select()[0].slug == 'service-ett-civil'
-    assert Role.select()[0].details is None
-    assert Role.select()[0].emails is None
-    assert Role.select()[0].emails_to_members is False
+    assert pub.role_class.count() == 1
+    assert pub.role_class.select()[0].name == 'Service étt civil'
+    assert pub.role_class.select()[0].slug == 'service-ett-civil'
+    assert pub.role_class.select()[0].details is None
+    assert pub.role_class.select()[0].emails is None
+    assert pub.role_class.select()[0].emails_to_members is False
     CmdHoboNotify.process_notification(notification)
-    assert Role.count() == 1
-    assert Role.select()[0].name == 'Service étt civil'
-    assert Role.select()[0].slug == 'service-ett-civil'
-    assert Role.select()[0].details is None
-    assert Role.select()[0].emails is None
-    assert Role.select()[0].emails_to_members is False
+    assert pub.role_class.count() == 1
+    assert pub.role_class.select()[0].name == 'Service étt civil'
+    assert pub.role_class.select()[0].slug == 'service-ett-civil'
+    assert pub.role_class.select()[0].details is None
+    assert pub.role_class.select()[0].emails is None
+    assert pub.role_class.select()[0].emails_to_members is False
 
 
 def test_process_notification_role(pub):
-    User = pub.user_class
-
+    uuid1 = str(uuid.uuid4())
+    uuid2 = str(uuid.uuid4())
     notification = {
         '@type': u'provision',
         'audience': [u'test'],
@@ -94,7 +90,7 @@ def test_process_notification_role(pub):
                     'name': u'Service enfance',
                     'slug': u'service-enfance',
                     'details': u'Rôle du service petite enfance',
-                    'uuid': u'12345',
+                    'uuid': uuid1,
                     'emails': [u'petite-enfance@example.com'],
                     'emails_to_members': False,
                 },
@@ -102,34 +98,34 @@ def test_process_notification_role(pub):
                     'name': u'Service état civil',
                     'slug': u'service-ett-civil',
                     'details': u'Rôle du service état civil',
-                    'uuid': u'xyz',
+                    'uuid': uuid2,
                     'emails': [u'etat-civil@example.com'],
                     'emails_to_members': True,
                 },
             ],
         },
     }
-    assert Role.count() == 1
-    assert Role.select()[0].name == 'Service étt civil'
-    assert Role.select()[0].slug == 'service-ett-civil'
-    assert Role.select()[0].details is None
-    assert Role.select()[0].emails is None
-    assert Role.select()[0].emails_to_members is False
-    existing_role_id = Role.select()[0].id
+    assert pub.role_class.count() == 1
+    assert pub.role_class.select()[0].name == 'Service étt civil'
+    assert pub.role_class.select()[0].slug == 'service-ett-civil'
+    assert pub.role_class.select()[0].details is None
+    assert pub.role_class.select()[0].emails is None
+    assert pub.role_class.select()[0].emails_to_members is False
+    existing_role_id = pub.role_class.select()[0].id
     CmdHoboNotify.process_notification(notification)
-    assert Role.count() == 2
-    old_role = Role.get(existing_role_id)
+    assert pub.role_class.count() == 2
+    old_role = pub.role_class.get(existing_role_id)
     assert old_role.name == 'Service état civil'
-    assert old_role.uuid == 'xyz'
+    assert old_role.uuid == uuid2
     assert old_role.slug == 'service-ett-civil'
     assert old_role.details == "Rôle du service état civil"
     assert old_role.emails == ['etat-civil@example.com']
     assert old_role.emails_to_members is True
-    new_role = Role.get_on_index('12345', 'uuid')
-    assert new_role.id == '12345'
+    new_role = pub.role_class.get_on_index(uuid1, 'uuid')
+    assert new_role.id == uuid1
     assert new_role.name == 'Service enfance'
     assert new_role.slug == 'service-enfance'
-    assert new_role.uuid == '12345'
+    assert new_role.uuid == uuid1
     assert new_role.details == "Rôle du service petite enfance"
     assert new_role.emails == ['petite-enfance@example.com']
     assert new_role.emails_to_members is False
@@ -145,7 +141,7 @@ def test_process_notification_role(pub):
                     'name': u'Service enfance',
                     'slug': u'service-enfance',
                     'description': u'Rôle du service petite enfance',
-                    'uuid': u'12345',
+                    'uuid': uuid1,
                     'emails': [u'petite-enfance@example.com'],
                     'emails_to_members': True,
                 },
@@ -153,18 +149,18 @@ def test_process_notification_role(pub):
         },
     }
     CmdHoboNotify.process_notification(notification)
-    assert Role.count() == 1
-    assert Role.select()[0].id == new_role.id
-    assert Role.select()[0].uuid == '12345'
-    assert Role.select()[0].name == 'Service enfance'
-    assert Role.select()[0].slug == 'service-enfance'
-    assert Role.select()[0].details is None
-    assert Role.select()[0].emails == ['petite-enfance@example.com']
-    assert Role.select()[0].emails_to_members is True
+    assert pub.role_class.count() == 1
+    assert pub.role_class.select()[0].id == new_role.id
+    assert pub.role_class.select()[0].uuid == uuid1
+    assert pub.role_class.select()[0].name == 'Service enfance'
+    assert pub.role_class.select()[0].slug == 'service-enfance'
+    assert pub.role_class.select()[0].details is None
+    assert pub.role_class.select()[0].emails == ['petite-enfance@example.com']
+    assert pub.role_class.select()[0].emails_to_members is True
 
 
 def test_process_notification_internal_role(pub):
-    Role.wipe()
+    pub.role_class.wipe()
 
     notification = {
         '@type': u'provision',
@@ -177,7 +173,7 @@ def test_process_notification_internal_role(pub):
                     'name': u'Service enfance',
                     'slug': u'_service-enfance',
                     'details': u'Rôle du service petite enfance',
-                    'uuid': u'12345',
+                    'uuid': str(uuid.uuid4()),
                     'emails': [u'petite-enfance@example.com'],
                     'emails_to_members': False,
                 },
@@ -185,15 +181,15 @@ def test_process_notification_internal_role(pub):
         },
     }
     CmdHoboNotify.process_notification(notification)
-    assert Role.count() == 1
-    role = Role.select()[0]
+    assert pub.role_class.count() == 1
+    role = pub.role_class.select()[0]
     assert role.is_internal()
 
 
 def test_process_notification_role_description(pub):
-    User = pub.user_class
-
     # check descriptions are not used to fill role.details
+    uuid1 = str(uuid.uuid4())
+    uuid2 = str(uuid.uuid4())
     notification = {
         '@type': u'provision',
         'audience': [u'test'],
@@ -205,7 +201,7 @@ def test_process_notification_role_description(pub):
                     'name': u'Service enfance',
                     'slug': u'service-enfance',
                     'description': u'Rôle du service petite enfance',
-                    'uuid': u'12345',
+                    'uuid': uuid1,
                     'emails': [u'petite-enfance@example.com'],
                     'emails_to_members': False,
                 },
@@ -213,33 +209,33 @@ def test_process_notification_role_description(pub):
                     'name': u'Service état civil',
                     'slug': u'service-ett-civil',
                     'description': u'Rôle du service état civil',
-                    'uuid': u'xyz',
+                    'uuid': uuid2,
                     'emails': [u'etat-civil@example.com'],
                     'emails_to_members': True,
                 },
             ],
         },
     }
-    assert Role.count() == 1
-    assert Role.select()[0].name == 'Service étt civil'
-    assert Role.select()[0].slug == 'service-ett-civil'
-    assert Role.select()[0].details is None
-    assert Role.select()[0].emails is None
-    assert Role.select()[0].emails_to_members is False
-    existing_role_id = Role.select()[0].id
+    assert pub.role_class.count() == 1
+    assert pub.role_class.select()[0].name == 'Service étt civil'
+    assert pub.role_class.select()[0].slug == 'service-ett-civil'
+    assert pub.role_class.select()[0].details is None
+    assert pub.role_class.select()[0].emails is None
+    assert pub.role_class.select()[0].emails_to_members is False
+    existing_role_id = pub.role_class.select()[0].id
     CmdHoboNotify.process_notification(notification)
-    assert Role.count() == 2
-    old_role = Role.get(existing_role_id)
+    assert pub.role_class.count() == 2
+    old_role = pub.role_class.get(existing_role_id)
     assert old_role.name == 'Service état civil'
     assert old_role.slug == 'service-ett-civil'
-    assert old_role.uuid == 'xyz'
+    assert old_role.uuid == uuid2
     assert old_role.details is None
     assert old_role.emails == ['etat-civil@example.com']
     assert old_role.emails_to_members is True
-    new_role = Role.get_on_index('12345', 'uuid')
+    new_role = pub.role_class.get_on_index(uuid1, 'uuid')
     assert new_role.name == 'Service enfance'
     assert new_role.slug == 'service-enfance'
-    assert new_role.uuid == '12345'
+    assert new_role.uuid == uuid1
     assert new_role.details is None
     assert new_role.emails == ['petite-enfance@example.com']
     assert new_role.emails_to_members is False
@@ -255,7 +251,7 @@ def test_process_notification_role_description(pub):
                     'name': u'Service enfance',
                     'slug': u'service-enfance',
                     'description': u'Rôle du service petite enfance',
-                    'uuid': u'12345',
+                    'uuid': uuid1,
                     'emails': [u'petite-enfance@example.com'],
                     'emails_to_members': True,
                 },
@@ -263,19 +259,18 @@ def test_process_notification_role_description(pub):
         },
     }
     CmdHoboNotify.process_notification(notification)
-    assert Role.count() == 1
-    assert Role.select()[0].id == new_role.id
-    assert Role.select()[0].name == 'Service enfance'
-    assert Role.select()[0].uuid == '12345'
-    assert Role.select()[0].slug == 'service-enfance'
-    assert Role.select()[0].details is None
-    assert Role.select()[0].emails == ['petite-enfance@example.com']
-    assert Role.select()[0].emails_to_members is True
+    assert pub.role_class.count() == 1
+    assert pub.role_class.select()[0].id == new_role.id
+    assert pub.role_class.select()[0].name == 'Service enfance'
+    assert pub.role_class.select()[0].uuid == uuid1
+    assert pub.role_class.select()[0].slug == 'service-enfance'
+    assert pub.role_class.select()[0].details is None
+    assert pub.role_class.select()[0].emails == ['petite-enfance@example.com']
+    assert pub.role_class.select()[0].emails_to_members is True
 
 
 def test_process_notification_role_deprovision(pub):
-    User = pub.user_class
-
+    uuid1 = str(uuid.uuid4())
     notification = {
         '@type': u'deprovision',
         'audience': [u'test'],
@@ -285,34 +280,34 @@ def test_process_notification_role_deprovision(pub):
             'data': [
                 {
                     '@type': 'role',
-                    'uuid': u'xyz',
+                    'uuid': uuid1,
                 },
             ],
         },
     }
-    role = Role.select()[0]
+    role = pub.role_class.select()[0]
     role.remove_self()
     assert role.name == 'Service étt civil'
     assert role.slug == 'service-ett-civil'
-    role.id = 'xyz'
+    role.id = uuid1
     role.store()
 
-    role = Role('foo')
+    role = pub.role_class('foo')
     role.slug = 'bar'
     role.store()
 
-    assert Role.count() == 2
+    assert pub.role_class.count() == 2
     CmdHoboNotify.process_notification(notification)
-    assert Role.count() == 1
-    assert Role.select()[0].slug == 'bar'
+    assert pub.role_class.count() == 1
+    assert pub.role_class.select()[0].slug == 'bar'
 
-    r = Role(name='Service étt civil')
-    r.uuid = 'xyz'
+    r = pub.role_class(name='Service étt civil')
+    r.uuid = uuid1
     r.store()
-    assert Role.count() == 2
+    assert pub.role_class.count() == 2
     CmdHoboNotify.process_notification(notification)
-    assert Role.count() == 1
-    assert Role.select()[0].slug == 'bar'
+    assert pub.role_class.count() == 1
+    assert pub.role_class.select()[0].slug == 'bar'
 
 
 PROFILE = {
@@ -451,6 +446,8 @@ def test_process_notification_user_provision(pub):
     # setup an hobo profile
     CmdCheckHobos().update_profile(PROFILE, pub)
 
+    uuid1 = str(uuid.uuid4())
+    uuid2 = str(uuid.uuid4())
     notification = {
         '@type': u'provision',
         'audience': [u'test'],
@@ -462,7 +459,7 @@ def test_process_notification_user_provision(pub):
                     'name': u'Service enfance',
                     'slug': u'service-enfance',
                     'description': u'Rôle du service petite enfance',
-                    'uuid': u'12345',
+                    'uuid': uuid1,
                     'emails': [u'petite-enfance@example.com'],
                     'emails_to_members': False,
                 },
@@ -470,33 +467,33 @@ def test_process_notification_user_provision(pub):
                     'name': u'Service état civil',
                     'slug': u'service-ett-civil',
                     'description': u'Rôle du service état civil',
-                    'uuid': u'xyz',
+                    'uuid': uuid2,
                     'emails': [u'etat-civil@example.com'],
                     'emails_to_members': True,
                 },
             ],
         },
     }
-    assert Role.count() == 1
-    assert Role.select()[0].name == 'Service étt civil'
-    assert Role.select()[0].slug == 'service-ett-civil'
-    assert Role.select()[0].details is None
-    assert Role.select()[0].emails is None
-    assert Role.select()[0].emails_to_members is False
-    existing_role_id = Role.select()[0].id
+    assert pub.role_class.count() == 1
+    assert pub.role_class.select()[0].name == 'Service étt civil'
+    assert pub.role_class.select()[0].slug == 'service-ett-civil'
+    assert pub.role_class.select()[0].details is None
+    assert pub.role_class.select()[0].emails is None
+    assert pub.role_class.select()[0].emails_to_members is False
+    existing_role_id = pub.role_class.select()[0].id
     CmdHoboNotify.process_notification(notification)
-    assert Role.count() == 2
-    old_role = Role.get(existing_role_id)
+    assert pub.role_class.count() == 2
+    old_role = pub.role_class.get(existing_role_id)
     assert old_role.name == 'Service état civil'
-    assert old_role.uuid == 'xyz'
+    assert old_role.uuid == uuid2
     assert old_role.slug == 'service-ett-civil'
     assert old_role.details is None
     assert old_role.emails == ['etat-civil@example.com']
     assert old_role.emails_to_members is True
-    new_role = Role.get_on_index('12345', 'uuid')
+    new_role = pub.role_class.get_on_index(uuid1, 'uuid')
     assert new_role.name == 'Service enfance'
     assert new_role.slug == 'service-enfance'
-    assert new_role.uuid == '12345'
+    assert new_role.uuid == uuid1
     assert new_role.details is None
     assert new_role.emails == ['petite-enfance@example.com']
     assert new_role.emails_to_members is False
@@ -518,12 +515,12 @@ def test_process_notification_user_provision(pub):
                     'is_active': True,
                     u'roles': [
                         {
-                            u'uuid': u'12345',
+                            u'uuid': uuid1,
                             u'name': u'Service petite enfance',
                             u'description': u'etc.',
                         },
                         {
-                            u'uuid': u'xyz',
+                            u'uuid': uuid2,
                             u'name': u'Service état civil',
                             u'description': u'etc.',
                         },
@@ -565,12 +562,12 @@ def test_process_notification_user_provision(pub):
                     'is_active': False,
                     u'roles': [
                         {
-                            u'uuid': u'xyz',
+                            u'uuid': uuid2,
                             u'name': u'Service état civil',
                             u'description': u'etc.',
                         },
                         {
-                            u'uuid': u'unknown-uuid',
+                            u'uuid': str(uuid.uuid4()),
                             u'name': u'Service enfance',
                             u'description': u'',
                         },
@@ -612,7 +609,7 @@ def test_process_notification_user_provision(pub):
                         u'is_superuser': True,
                         u'roles': [
                             {
-                                u'uuid': u'xyz',
+                                u'uuid': uuid2,
                                 u'name': u'Service état civil',
                                 u'description': u'etc.',
                             },
@@ -647,12 +644,12 @@ def test_process_notification_user_provision(pub):
                         'is_superuser': False,
                         'roles': [
                             {
-                                'uuid': '12345',
+                                'uuid': uuid1,
                                 'name': 'Service petite enfance',
                                 'description': 'etc.',
                             },
                             {
-                                'uuid': 'xyz',
+                                'uuid': uuid2,
                                 'name': 'Service état civil',
                                 'description': 'etc.',
                             },
@@ -678,7 +675,7 @@ def test_process_notification_user_with_errors(pub):
     from wcs.ctl.check_hobos import CmdCheckHobos
 
     User.wipe()
-    Role.wipe()
+    pub.role_class.wipe()
     CmdCheckHobos().update_profile(PROFILE, pub)
 
     notification = {
@@ -737,7 +734,7 @@ def test_process_notification_user_with_errors(pub):
 def test_process_notification_role_with_errors(pub):
     User = pub.user_class
     User.wipe()
-    Role.wipe()
+    pub.role_class.wipe()
     notification = {
         '@type': u'provision',
         'audience': [u'test'],
@@ -759,14 +756,14 @@ def test_process_notification_role_with_errors(pub):
     with pytest.raises(KeyError) as e:
         CmdHoboNotify.process_notification(notification)
     assert e.value.args == ('role without uuid',)
-    assert Role.count() == 0
+    assert pub.role_class.count() == 0
 
     notification['objects']['data'][0]['uuid'] = u'12345'
     del notification['objects']['data'][0]['name']
     with pytest.raises(ValueError) as e:
         CmdHoboNotify.process_notification(notification)
     assert e.value.args == ('invalid role',)
-    assert Role.count() == 0
+    assert pub.role_class.count() == 0
 
 
 def test_process_user_deprovision(pub):
@@ -776,7 +773,7 @@ def test_process_user_deprovision(pub):
     from wcs.ctl.check_hobos import CmdCheckHobos
 
     User.wipe()
-    Role.wipe()
+    pub.role_class.wipe()
     CmdCheckHobos().update_profile(PROFILE, pub)
 
     user = User()
diff --git a/tests/test_role.py b/tests/test_role.py
index 1b65b8f1..cabc4d51 100644
--- a/tests/test_role.py
+++ b/tests/test_role.py
@@ -4,8 +4,7 @@ import pickle
 
 from utilities import create_temporary_pub, clean_temporary_pub
 
-from wcs.qommon.storage import StorableObject
-from wcs.roles import Role, get_user_roles
+from wcs.roles import get_user_roles
 
 from quixote import get_publisher
 
@@ -21,47 +20,47 @@ def teardown_module(module):
 
 
 def test_slug():
-    Role.wipe()
-    role = Role(name='Hello world')
+    get_publisher().role_class.wipe()
+    role = get_publisher().role_class(name='Hello world')
     role.store()
     assert role.slug == 'hello-world'
 
 
 def test_duplicated_name():
-    Role.wipe()
-    role = Role(name='Hello world')
+    get_publisher().role_class.wipe()
+    role = get_publisher().role_class(name='Hello world')
     role.store()
     assert role.slug == 'hello-world'
-    role = Role(name='Hello world')
+    role = get_publisher().role_class(name='Hello world')
     role.store()
     assert role.slug == 'hello-world-1'
 
 
 def test_migrate():
-    Role.wipe()
-    role = Role(name='Hello world')
+    get_publisher().role_class.wipe()
+    role = get_publisher().role_class(name='Hello world')
     role.store()
     obj = pickle.load(open(role.get_object_filename(), 'rb'))
     del obj.slug
     pickle.dump(obj, open(role.get_object_filename(), 'wb'))
     assert pickle.load(open(role.get_object_filename(), 'rb')).slug is None
-    assert Role.get(role.id).slug == 'hello-world'
+    assert get_publisher().role_class.get(role.id).slug == 'hello-world'
 
 
 def test_get_user_roles():
-    Role.wipe()
-    Role(name='f1').store()
-    Role(name='é1').store()
-    Role(name='a1').store()
+    get_publisher().role_class.wipe()
+    get_publisher().role_class(name='f1').store()
+    get_publisher().role_class(name='é1').store()
+    get_publisher().role_class(name='a1').store()
     assert [x[1] for x in get_user_roles()] == ['a1', 'é1', 'f1']
 
 
 def test_get_emails():
     User = get_publisher().user_class
     User.wipe()
-    Role.wipe()
+    get_publisher().role_class.wipe()
 
-    role = Role(name='role')
+    role = get_publisher().role_class(name='role')
     role.emails_to_members = True
     role.store()
 
diff --git a/tests/test_saml_auth.py b/tests/test_saml_auth.py
index 6a51fbc3..393c2093 100644
--- a/tests/test_saml_auth.py
+++ b/tests/test_saml_auth.py
@@ -1,7 +1,7 @@
 import datetime
 import os
-import sys
 import shutil
+import uuid
 import urllib.parse
 
 try:
@@ -19,7 +19,6 @@ from wcs.qommon.saml2 import Saml2Directory
 from wcs.qommon.ident.idp import MethodAdminDirectory, AdminIDPDir
 from wcs.qommon import sessions, x509utils
 from wcs.qommon.errors import RequestError
-from wcs.roles import Role
 
 from utilities import get_app, create_temporary_pub, clean_temporary_pub
 
@@ -39,6 +38,9 @@ IDP_METADATA = """<?xml version="1.0"?>
   </ns0:IDPSSODescriptor>
 </ns0:EntityDescriptor>"""
 
+role_uuid1 = str(uuid.uuid4())
+role_uuid2 = str(uuid.uuid4())
+
 
 def pytest_generate_tests(metafunc):
     if 'pub' in metafunc.fixturenames:
@@ -169,7 +171,7 @@ def get_authn_response_msg(pub, ni_format=lasso.SAML2_NAME_IDENTIFIER_FORMAT_PER
     role_slug_attribute.name = 'role-slug'
     role_slug_attribute.nameFormat = lasso.SAML2_ATTRIBUTE_NAME_FORMAT_BASIC
     role_uuids = []
-    for role_uuid in ('foo', 'bar'):
+    for role_uuid in (role_uuid1, role_uuid2):
         text_node = lasso.MiscTextNode.newWithString(role_uuid)
         text_node.textChild = True
         atv = lasso.Saml2AttributeValue()
@@ -263,9 +265,9 @@ def test_assertion_consumer_existing_federation(pub, caplog):
     pub.write_cfg()
     pub.set_config()
 
-    Role.wipe()
-    role = Role('Foo')
-    role.uuid = 'foo'
+    pub.role_class.wipe()
+    role = pub.role_class('Foo')
+    role.uuid = role_uuid1
     role.store()
 
     # 1st pass to generate a user
@@ -280,10 +282,10 @@ def test_assertion_consumer_existing_federation(pub, caplog):
     assert user.verified_fields
     assert len(user.verified_fields) == 3
     assert user.form_data['_birthdate'].tm_year == 2000
-    assert user.roles == [role.id]  # bar uuid is ignored as unknown
+    assert user.roles == [role.id]  # other uuid is ignored as unknown
 
     assert ('enrolling user %s in Foo' % user.id) in [x.message for x in caplog.records]
-    assert 'role uuid bar is unknown' in [x.message for x in caplog.records]
+    assert 'role uuid %s is unknown' % role_uuid2 in [x.message for x in caplog.records]
 
     req = HTTPRequest(
         None,
diff --git a/tests/test_snapshots.py b/tests/test_snapshots.py
index dc4002bf..264d8ea0 100644
--- a/tests/test_snapshots.py
+++ b/tests/test_snapshots.py
@@ -149,7 +149,7 @@ def test_snapshot_user(pub):
 
 def test_form_snapshot_comments(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
     app = login(get_app(pub))
     resp = app.get('/backoffice/forms/')
 
@@ -178,7 +178,7 @@ def test_form_snapshot_comments(pub):
 
 def test_form_snapshot_history(pub, formdef_with_history):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
     app = login(get_app(pub))
     resp = app.get('/backoffice/forms/%s/' % formdef_with_history.id)
     resp = resp.click('History')
@@ -194,7 +194,7 @@ def test_form_snapshot_history(pub, formdef_with_history):
 
 def test_form_snapshot_export(pub, formdef_with_history):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
     app = login(get_app(pub))
     resp = app.get('/backoffice/forms/%s/history/' % formdef_with_history.id)
 
@@ -206,7 +206,7 @@ def test_form_snapshot_export(pub, formdef_with_history):
 
 def test_form_snapshot_restore(pub, formdef_with_history):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
     app = login(get_app(pub))
 
     # restore as new
@@ -233,7 +233,7 @@ def test_form_snapshot_restore(pub, formdef_with_history):
 
 def test_block_snapshot_browse(pub, blocks_feature):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     BlockDef.wipe()
     blockdef = BlockDef()
@@ -256,7 +256,7 @@ def test_block_snapshot_browse(pub, blocks_feature):
 
 def test_card_snapshot_browse(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     CardDef.wipe()
     carddef = CardDef()
@@ -298,7 +298,7 @@ def test_card_snapshot_browse(pub):
 
 def test_datasource_snapshot_browse(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     NamedDataSource.wipe()
     datasource = NamedDataSource(name='test')
@@ -322,7 +322,7 @@ def test_datasource_snapshot_browse(pub):
 
 def test_form_snapshot_browse(pub, formdef_with_history):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
     app = login(get_app(pub))
 
     pub.custom_view_class.wipe()
@@ -378,7 +378,7 @@ def test_form_snapshot_browse(pub, formdef_with_history):
 
 def test_workflow_snapshot_browse(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     Workflow.wipe()
     workflow = Workflow(name='test')
@@ -399,7 +399,7 @@ def test_workflow_snapshot_browse(pub):
 
 def test_workflow_with_model_snapshot_browse(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     Workflow.wipe()
     if os.path.exists(os.path.join(pub.app_dir, 'models')):
@@ -442,7 +442,7 @@ def test_workflow_with_model_snapshot_browse(pub):
 
 def test_workflow_with_form_snapshot_browse(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     Workflow.wipe()
     wf = Workflow(name='status')
@@ -466,7 +466,7 @@ def test_workflow_with_form_snapshot_browse(pub):
 
 def test_wscall_snapshot_browse(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     NamedWsCall.wipe()
     wscall = NamedWsCall(name='test')
@@ -489,7 +489,7 @@ def test_wscall_snapshot_browse(pub):
 
 def test_form_snapshot_save(pub, formdef_with_history):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
     app = login(get_app(pub))
 
     resp = app.get('/backoffice/forms/%s/' % formdef_with_history.id)
@@ -522,7 +522,7 @@ def test_form_snapshot_save(pub, formdef_with_history):
 
 def test_snaphost_workflow_status_item_comments(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     Workflow.wipe()
     workflow = Workflow(name='test')
diff --git a/tests/test_sql.py b/tests/test_sql.py
index b9318346..f5d50e39 100644
--- a/tests/test_sql.py
+++ b/tests/test_sql.py
@@ -18,7 +18,6 @@ from wcs.qommon import force_str
 from wcs import publisher, fields
 from wcs.formdef import FormDef
 from wcs.formdata import Evolution
-from wcs.roles import Role
 from wcs.workflows import Workflow, CommentableWorkflowStatusItem, WorkflowCriticalityLevel
 from wcs.wf.jump import JumpWorkflowStatusItem
 from wcs.wf.register_comment import RegisterCommenterWorkflowStatusItem
@@ -1911,7 +1910,7 @@ def test_view_performances():
     # create roles
     roles = []
     for i in range(nb_roles):
-        role = Role(name='role%s' % i)
+        role = pub.role_class(name='role%s' % i)
         role.store()
         roles.append(role)
 
